<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.06.01 - Build 20.06.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
$DA->KonsolenAusgabe('Beginn der Datenverarbeitung',1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);
	if ( $DA->cli_parameter['jahr'] === 0 )
	$DA->KonsolenAusgabe('Es wurde kein Jahr mit "--jahr=[jahr]" angegeben',-1);

$klima = $DA->HoleVergleichsMittelDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$daten = $DA->HoleStationsDatenDesJahres($DA->cli_parameter['station'],$DA->cli_parameter['jahr']);
$jahres_abweichung = array();

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);

$DA->KonsolenAusgabe('Erstellen der Vektorgrafik',1);
$DA->VektorGrafikPuffer('text','x=10,y=24,style=font-family:%fn;font-size:20px',date('r'));
$DA->VektorGrafikPuffer('rect','x=0,y=0,width=%w,height=%h,fill=url(#bg-gradient),stroke=black,stroke-width=3px');
$DA->VektorGrafikPuffer('rect','x=!,y=!,width=%w-!!,height=%h-!!,fill=white,stroke=black,stroke-width=1px');
$DA->VektorGrafikPuffer('text','x=20,y=%h-4,style=font-family:%fn;font-size:6pt;opacity:0.2;','Erstellt mit "Wetter-Analyse in Dekaden/'.WADE_VERSION_STRING.'" am '.date('r'));

$DA->KonsolenAusgabe('Bearbeite Y-Achse des Diagramms',2);

	for ( $wert = -10 ; $wert <= 10 ; $wert++ ){
	$basis_y = $DA->BerechneYAchse($wert);
	$DA->VektorGrafikPuffer('line','x1=!,y1='.$basis_y[0].',x2=%w-!,y2='.$basis_y[0].',stroke=gray,stroke-width=0.25px');
	$DA->VektorGrafikPuffer('line','x1=!-5,y1='.$basis_y[0].',x2=!,y2='.$basis_y[0].',stroke=black,stroke-width=1px');
	$wert_str = ( $wert > 0 ) ? '+'.$wert : $wert;
		if ( $wert !== 0 )
		$DA->VektorGrafikPuffer('text','x=8,y='.intval($basis_y[0]+5).',style=font-family:monospace;font-size:16px',$wert_str);
	}

$DA->KonsolenAusgabe('Bearbeite X-Achse des Diagramms',2);
$spalte = 0;

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$null ){
		if ( !isset($klima) || !isset($daten) )
		break;

		if ( $spalte === 0 ){
			foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
			$balken_name = explode(',',$balken_name);
				if ( in_array('werte_zeigen',$balken_name,true) ){
				$basis_y = ($balken_schluessel*14)+$einstellungen['grafik']['diagramm_abstand'];
				$DA->VektorGrafikPuffer('rect','x=!,y='.$basis_y.',width=%w-!!,height=14,fill='.$balken_name[1].',stroke=none,opacity=0.4');
				}
			}
		}

	$zellenbreite = (sizeof($einstellungen['grafik']['diagramm_balken_daten'])+1)*$einstellungen['grafik']['diagramm_balken_breite'];
	$basis_x = $spalte*$zellenbreite;
	$basis_x += $einstellungen['grafik']['diagramm_abstand'];
		if ( $basis_x+$zellenbreite > $einstellungen['grafik']['breite'] )
		break;

		foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
		$balken_name = explode(',',$balken_name);
			if ( !isset($daten[$dekade][$balken_name[0]]) )
			continue;
			if ( !isset($jahres_abweichung[$balken_name[0]]) )
			$jahres_abweichung[$balken_name[0]] = array();
		$wert_klima = $klima[$dekade][$balken_name[0]];
		$wert_aktuell = $daten[$dekade][$balken_name[0]];
		$abweichung = round($wert_aktuell-$wert_klima,1);
		$jahres_abweichung[$balken_name[0]][] = $abweichung;
		$basis_y = $DA->BerechneYAchse($abweichung);
		$DA->VektorGrafikPuffer('rect','x='.($basis_x+4+($balken_schluessel*$einstellungen['grafik']['diagramm_balken_breite'])).',
			y='.$basis_y[1].',width='.$einstellungen['grafik']['diagramm_balken_breite'].',height='.$basis_y[2].',
			stroke=black,fill='.$balken_name[1].',stroke-width=1px,rx=2,ry=2,opacity='.doubleval($balken_name[3]));
			if ( in_array('werte_zeigen',$balken_name,true) ){
			$basis_y = ($balken_schluessel*14)+$einstellungen['grafik']['diagramm_abstand'];
			$DA->VektorGrafikPuffer('text','x='.($basis_x+2).',y='.($basis_y+10).',style=font-size:'.$einstellungen['grafik']['schriftgroesse_werte_zeigen'].';',number_format($wert_aktuell,1));
			}
		}

	$DA->VektorGrafikPuffer('line','x1='.$basis_x.',y1=%h-!,x2='.$basis_x.',y2=%h-45,stroke=black,stroke-width=1px');
	$dekade = explode(chr(10),$DA->DekadeNachString($dekade));
	$DA->VektorGrafikPuffer('text','x='.($basis_x+10).',y=%h-30,style=font-family:%fn;font-size:12px',$dekade[1]);
		if ( (int)$dekade[1] === 2 )
		$DA->VektorGrafikPuffer('text','x='.$basis_x.',y=%h-15,style=font-family:%fn;font-size:16px;font-weight:bold;',$dekade[0]);
		if ( $spalte % 3 === 0 && $spalte !== 1 )
		$DA->VektorGrafikPuffer('line','x1='.$basis_x.',y1=!,x2='.$basis_x.',y2=%h-!,stroke=black,stroke-width=1px');
	$spalte++;
	}

$zellenbreite = (sizeof($einstellungen['grafik']['diagramm_balken_daten'])+1)*$einstellungen['grafik']['diagramm_balken_breite'];
$basis_x = $spalte*$zellenbreite;
$basis_x += $einstellungen['grafik']['diagramm_abstand'];
$DA->VektorGrafikPuffer('line','x1='.$basis_x.',y1=!,x2='.$basis_x.',y2=%h-!,stroke=black,stroke-width=1px');

$DA->KonsolenAusgabe('Bearbeite Legende',2);

$DA->VektorGrafikPuffer('text','x=!,y=!-10,style=font-family:%fh;font-size:28px','Wetter-Rückblick des Jahres '.$DA->cli_parameter['jahr']);
$DA->VektorGrafikPuffer('text','x=650,y=!-20,style=font-family:%fh;font-size:14px','Name der Station: '.
	$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
	' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].
	') - '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle']);
$DA->VektorGrafikPuffer('text','x=650,y=!-6,style=font-family:%fh;font-size:14px','Mittel der Jahre zum Vergleich: '.$DA->cli_parameter['vergleich']);

	foreach ( $einstellungen['grafik']['diagramm_balken_daten'] as $balken_schluessel=>$balken_name ){
	$basis_x = ($balken_schluessel*150)+$einstellungen['grafik']['diagramm_abstand'];
	$balken_name = explode(',',$balken_name);
		if ( !isset($jahres_abweichung[$balken_name[0]]) )
		continue;
	$abweichung = array_sum($jahres_abweichung[$balken_name[0]])/sizeof($jahres_abweichung[$balken_name[0]]);
	$DA->VektorGrafikPuffer('rect','x='.$basis_x.',y=4,width=8,height=8,fill='.$balken_name[1].',stroke=black,stroke-width=1px');
	$DA->VektorGrafikPuffer('text','x='.($basis_x+12).',y=12,style=font-family:%fn;font-size:10px',$balken_name[2].' ['.round($abweichung,1).']');
	}

$basis_y = $DA->BerechneYAchse(0);
$DA->VektorGrafikPuffer('line','x1=!,y1='.$basis_y[0].',x2=%w-!,y2='.$basis_y[0].',stroke=black,stroke-width=3px');

$DA->VektorGrafikZeichnen();
$DA->KonsolenAusgabe('Vektorgrafik gezeichet in "'.$einstellungen['grafik']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);

?>
