<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 11.06.01 - Build 20.06.2011
 * Lizenziert unter 'Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)'
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
$DA->KonsolenAusgabe('Beginn der Datenverarbeitung',1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);

$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$daten_temp = array();
$rekorde = array();

$DA->KonsolenAusgabe('Erstelle Grundgerüst für Rekordwerte-Ermittlung',2);

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
	$rekorde[$dekade] = array();
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $schluessel ){
		$typ = 1;
			switch ( $typ ){
			case 1:
			$max = -99;
			$min = 99;
			break;
			}
		$rekorde[$dekade][$schluessel] = array(
		'alle'=>array('max'=>array($max,''),'min'=>array($min,'')),
		'einzel'=>array('max'=>array($max,''),'min'=>array($min,''))
		);
		}
	}

$DA->KonsolenAusgabe('Suche nach Rekorden für eine gesamte Dekade',2);

	foreach ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			if ( !isset($daten_temp[$schluessel][$rschluessel][$daten['jahr']]) )
			$daten_temp[$schluessel][$rschluessel][$daten['jahr']] = array();
		$daten_temp[$schluessel][$rschluessel][$daten['jahr']][] = $daten[$rschluessel];
		}
	}

	foreach ( $DA->grundgeruest_dekaden as $dekade=>$werte ){
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			foreach ( $daten_temp[$dekade][$rschluessel] as $jahr=>$daten ){
			$wert = round( array_sum($daten) / sizeof($daten), 1);
				if ( $wert > $rekorde[$dekade][$rschluessel]['alle']['max'][0] ){
				$rekorde[$dekade][$rschluessel]['alle']['max'][0] = $wert;
				$rekorde[$dekade][$rschluessel]['alle']['max'][1] = $jahr;
				}
				if ( $wert < $rekorde[$dekade][$rschluessel]['alle']['min'][0] ){
				$rekorde[$dekade][$rschluessel]['alle']['min'][0] = $wert;
				$rekorde[$dekade][$rschluessel]['alle']['min'][1] = $jahr;
				}
			}
		}
	}

$DA->KonsolenAusgabe('Suche nach Rekorden einzelner Tage einer gesamten Dekade',2);

	foreach  ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel ){
			if ( $daten[$rschluessel] > $rekorde[$schluessel][$rschluessel]['einzel']['max'][0] ){
			$rekorde[$schluessel][$rschluessel]['einzel']['max'][0] = $daten[$rschluessel];
			$rekorde[$schluessel][$rschluessel]['einzel']['max'][1] = sprintf('%02d.%02d.%04d',$daten['tag'],$daten['monat'],$daten['jahr']);
			}
			if ( $daten[$rschluessel] < $rekorde[$schluessel][$rschluessel]['einzel']['min'][0] ){
			$rekorde[$schluessel][$rschluessel]['einzel']['min'][0] = $daten[$rschluessel];
			$rekorde[$schluessel][$rschluessel]['einzel']['min'][1] = sprintf('%02d.%02d.%04d',$daten['tag'],$daten['monat'],$daten['jahr']);
			}
		}
	}

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);

$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
$DA->KonsolenAusgabe('Die Dekaden folgender Monate wurden ausgewählt '.$einstellungen['rekorde']['monate_anzeigen'],1);
$monate_anzeigen = explode(',',$einstellungen['rekorde']['monate_anzeigen']);
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= str_repeat('=',72).chr(13).chr(10); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
	$report .= 'DEKADEN-REKORDE IM ZEITRAUM '.$DA->cli_parameter['vergleich'].chr(10);
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.chr(13).chr(10);
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].chr(13).chr(10).chr(13).chr(10);
		foreach ( $rekorde as $dekade=>$daten ){
		$dekade_string = $DA->DekadeNachString($dekade,'%B');
		$monat = substr($dekade,0,strpos($dekade,'/'));
			if ( !in_array($monat,$monate_anzeigen) )
			continue;

		$report .= '#### '.str_replace(chr(10),' . ',$dekade_string).' ####'.chr(13).chr(10).chr(13).chr(10).chr(9);
			foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
			$report .= str_pad($rschluessel,20,' ',STR_PAD_RIGHT);

			if ( $einstellungen['rekorde']['maximum_rekorde_anzeigen'] ){
			$report .= chr(13).chr(10).'MAX'.chr(9);
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['alle']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['max'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= chr(13).chr(10).chr(9);
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['einzel']['max'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['max'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= chr(13).chr(10);
			}

			if ( $einstellungen['rekorde']['minimum_rekorde_anzeigen'] ){
			$report .= chr(13).chr(10).'MIN'.chr(9);
				if ( $einstellungen['rekorde']['dekaden_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['alle']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['alle']['min'][1].')',20,' ',STR_PAD_RIGHT);
				}
			$report .= chr(13).chr(10).chr(9);
				if ( $einstellungen['rekorde']['tages_rekorde_anzeigen'] ){
					foreach ( $einstellungen['rekorde']['datenreihen_auswerten'] as $rschluessel )
					$report .= str_pad(number_format($rekorde[$dekade][$rschluessel]['einzel']['min'][0],1).' ('.$rekorde[$dekade][$rschluessel]['einzel']['min'][1].')',20,' ',STR_PAD_RIGHT);
				}
			}

		$report .= chr(13).chr(10).chr(13).chr(10);
		}
	break;
	default:
	$report = print_r($rekorde,true);
	break;
	}

	if ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Report erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);

?>
